// Header File
// Created 1/29/2011; 1:17:39 PM

//******************************************************************************
//
// Project:         Jumpman 89
//
// file name:       jm_utilities.h
//
// author:          David Randall "Ranman" 
//                  derandall99@gmail.com
//
// notes::          Jumpman was originally created by Randy Glover for the
//                  Atari 400, Commodore 64, IBM PCjr, and Apple II in 1982
//
//******************************************************************************


#ifndef _jm_utilities_h
#define _jm_utilities_h

#include "BasicTypes.h"


typedef enum
{
	DIR_None = 0,
	DIR_Up,
	DIR_Down,
	DIR_Left,
	DIR_Right,
	DIR_UpLeft,
	DIR_UpRight,
	DIR_DownLeft,
	DIR_DownRight,
	DIR_Total
} DIR_Type;


typedef enum // used intermixed with DIR_Type
{
	CMD_None            = 0,
	CMD_DIR_Up          = DIR_Up,
	CMD_DIR_Down,
	CMD_DIR_Left,
	CMD_DIR_Right,
	CMD_DIR_UpLeft,
	CMD_DIR_UpRight,
	CMD_DIR_DownLeft,
	CMD_DIR_DownRight,
	CMD_Open            = DIR_Up,
	CMD_Close           = DIR_Down,
	CMD_Goto            = 16,
	CMD_Delay,
	CMD_Trigger,
	CMD_Toggle_Girders,
	CMD_Toggle_Rope_Ups,
	CMD_Toggle_Rope_Downs,
	CMD_Toggle_Ladders,
	CMD_Toggle_Bombs,
	CMD_Cmp_XLT,  
	CMD_Cmp_YLT,
	CMD_Cmp_XGT,
	CMD_Cmp_YGT,
	CMD_Cmp_XEQ,
	CMD_Cmp_YEQ,
	CMD_Total
} CMD_Type;

typedef enum
{
	STAGE_display_title,
	STAGE_load_level_file,
	STAGE_init_level,
	STAGE_display_level,
	STAGE_spawn_jumpman,
	STAGE_play_game,
	STAGE_dead_jumpman,
	STAGE_level_complete,
	STAGE_game_over,
	STAGE_high_scores,
	STAGE_high_scores_1,
	STAGE_high_scores_2,
	STAGE_high_scores_3,
	STAGE_pause_game,
} STAGE_Type;


extern bool exit_game;
extern bool reset_game;
extern int2 game_speed;
extern uint4 frame_count;
extern uint4 game_stage_count;
extern STAGE_Type game_stage;



void GetPlayerKeyPress(DIR_Type* direction, bool* action);
void SetGameStage(STAGE_Type new_game_stage);
bool AdjustGameSpeed(void);
void CheckExitGame(void);
void CheckResetGame(void);
void CheckAdjustContrast(void);
void CheckAutoQuit(uint4 value);
void ResetAutoQuit(void);

uint2 CalculateVpc(uint2* address, int2 size);
bool IsVpcValid(uint2* address, int2 size, uint2 vpc);

#endif