|******************************************************************************
|
| project name:    Generic Utilities
| author:          David Randall "Ranman" 
|                  derandall99@gmail.com
|
| compatible with HW1/HW2/HW3 on all AMS versions up to 3.10
|
|******************************************************************************



| C prototype:
|void GraySingleSprite8_COLOR_R(
|	register short x asm("%d0"),
|	register short y asm("%d1"),
|	register short h asm("%d2"),
|	unsigned char *sprt,    // a2
|	unsigned short color,   // d4
|	unsigned short eorMask, // d6
|	register void *dest0 asm("%a0"),
|	register void *dest1 asm("%a1"))
|	 __attribute__((__stkparm__));

| This is a modified version of GraySprite8_XOR_R
| Modifications by David Randall

.data
.globl myGraySingleSprite8_COLOR_R
.even

myGraySingleSprite8_COLOR_R:
    dbf      %d2,__Rest_of_GraySingleSprite8_COLOR_R
    rts

__Rest_of_GraySingleSprite8_COLOR_R:
|    movem.l  %d3/%a2,-(%sp)

|    move.l   12(%sp),%a2

    movem.l  %d3-%d6/%a2-%a3,-(%sp)

|    move.l   24(%sp),%a2
|    move.w   28(%sp),%d4

    move.l   28(%sp),%a2
    move.w   32(%sp),%d4
    move.w   34(%sp),%d6

|    move.w   #0x0000,%d6

__GraySingleSprite8_R__Test_WHITE:
    cmpi.w   #0,%d4
    bne      __GraySingleSprite8_R__Test_LTGRAY
    move    #0,%d5
    bra      __GraySingleSprite8_R__Test_Finish
__GraySingleSprite8_R__Test_LTGRAY:
    cmpi.w   #1,%d4
    bne      __GraySingleSprite8_R__Test_DKGRAY
    move    #8,%d5
    bra      __GraySingleSprite8_R__Test_Finish
__GraySingleSprite8_R__Test_DKGRAY:
    cmpi.w   #2,%d4
    bne      __GraySingleSprite8_R__Test_BLACK
    move    #16,%d5
    bra      __GraySingleSprite8_R__Test_Finish
__GraySingleSprite8_R__Test_BLACK:
    move    #24,%d5

__GraySingleSprite8_R__Test_Finish:

    move.w   %d1,%d3	| d3 = y
    lsl.w    #4,%d1	| d1 = 16*y
    sub.w    %d3,%d1	| d1 = 15*y

    move.w   %d0,%d3	| d3 = x
    lsr.w    #4,%d3	| d3 = x/16

    add.w    %d3,%d1	| d1 = 15*y + x/16
    add.w    %d1,%d1	| d1 = 30*y + x/8
    adda.w   %d1,%a0	| a0 += offset
    adda.w   %d1,%a1	| a1 += offset

    and.w    #0xF,%d0
    moveq    #8,%d1
    sub.w    %d0,%d1
    bge.s    __loop_GraySingleSprite8_COLOR_R_2

    neg.w    %d1

    lea      (%pc,__Color1a),%a3
    adda     %d5,%a3
| White on any color of bkgd
_loop_GraySingleSprite8_COLOR_R_1:
    moveq    #0,%d0
    move.b   (%a2)+,%d0
|    not.b    %d0
    eor.w    %d6,%d0
|    and.l    #0x000000FF,%d0
    swap.w   %d0
    lsr.l    %d1,%d0

|    not.l    %d0
|    and.l    %d0,(%a0)
|    and.l    %d0,(%a1)

    jmp      (%a3)  | jump to White, LtGray, DkGray, or Black
__Color1a:
| White
    not.l    %d0         | 2 bytes
    and.l    %d0,(%a0)   | 2 bytes
    and.l    %d0,(%a1)   | 2 bytes
    bra      __Color1    | 2 bytes
| LtGray
    or.l     %d0,(%a0)   | 2 bytes
    not.l    %d0         | 2 bytes
    and.l    %d0,(%a1)   | 2 bytes
    bra      __Color1    | 2 bytes
| DkGray
    or.l     %d0,(%a1)   | 2 bytes
    not.l    %d0         | 2 bytes
    and.l    %d0,(%a0)   | 2 bytes
    bra      __Color1    | 2 bytes
| Black
    or.l     %d0,(%a0)
    or.l     %d0,(%a1)

__Color1:

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,_loop_GraySingleSprite8_COLOR_R_1
    movem.l  (%sp)+,%d3-%d6/%a2-%a3
    rts

__loop_GraySingleSprite8_COLOR_R_2:
    lea      (%pc,__Color2a),%a3
    adda     %d5,%a3
_loop_GraySingleSprite8_COLOR_R_2:
    moveq    #0,%d0
    move.b   (%a2)+,%d0
|    not.b    %d0
    eor.w    %d6,%d0
|    and.l    #0x000000FF,%d0
    lsl.w    %d1,%d0

|    not.w    %d0
|    and.w    %d0,(%a0)
|    and.w    %d0,(%a1)

    jmp      (%a3)  | jump to White, LtGray, DkGray, or Black
__Color2a:
| White
    not.w    %d0         | 2 bytes
    and.w    %d0,(%a0)   | 2 bytes
    and.w    %d0,(%a1)   | 2 bytes
    bra      __Color2    | 2 bytes
| LtGray
    or.w     %d0,(%a0)   | 2 bytes
    not.w    %d0         | 2 bytes
    and.w    %d0,(%a1)   | 2 bytes
    bra      __Color2    | 2 bytes
| DkGray
    or.w     %d0,(%a1)   | 2 bytes
    not.w    %d0         | 2 bytes
    and.w    %d0,(%a0)   | 2 bytes
    bra      __Color2    | 2 bytes
| Black
    or.w     %d0,(%a0)
    or.w     %d0,(%a1)

__Color2:

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,_loop_GraySingleSprite8_COLOR_R_2
    movem.l  (%sp)+,%d3-%d6/%a2-%a3
    rts
